## net.sf.saxon.expr
Class VennExpression

    java.lang.Object
      net.sf.saxon.expr.ComputedExpression
          net.sf.saxon.expr.BinaryExpression
              net.sf.saxon.expr.VennExpression

All Implemented Interfaces:
  Container, Expression, InstructionInfoProvider, java.io.Serializable, javax.xml.transform.SourceLocator

public class VennExpression
extends BinaryExpression

An expression representing a nodeset that is a union, difference, or intersection of two other NodeSets

See Also:
  Serialized Form

Field Summary

Fields inherited from class net.sf.saxon.expr.BinaryExpression
`operand0, operand1, operator`

Fields inherited from class net.sf.saxon.expr.ComputedExpression
`locationId, staticProperties`

Fields inherited from interface net.sf.saxon.expr.Expression
`EVALUATE_METHOD, ITERATE_METHOD, PROCESS_METHOD`

Constructor Summary
`VennExpression(Expression p1, int op, Expression p2)` Constructor

Method Summary
`Expression` `analyze(StaticContext env, ItemType contextItemType)` Type-check the expression
`int` `computeCardinality()` Determine the static cardinality of the expression
`int` `computeSpecialProperties()` Get the static properties of this expression (other than its type).
`boolean` `effectiveBooleanValue(XPathContext context)` Get the effective boolean value.
`ItemType` `getItemType()` Determine the data type of the items returned by this expression
`int` `hashCode()` Is this expression the same as another expression?
`SequenceIterator` `iterate(XPathContext c)` Iterate over the value of the expression.
`Expression` `simplify(StaticContext env)` Simplify the expression

Methods inherited from class net.sf.saxon.expr.BinaryExpression
`display, displayOperator, equals, getOperands, getOperator, isCommutative, isInverse, iterateSubExpressions, promote`

Methods inherited from class net.sf.saxon.expr.ComputedExpression

`adoptChildExpression, checkPermittedContents, computeDependencies, computeStaticProperties, dynamicError, dynamicError, evaluateAsString, evaluateItem, getCardinality, getColumnNumber, getConstructType, getDependencies, getExecutable, getImplementationMethod, getInstructionInfo, getIntrinsicDependencies, getLineNumber, getLocationId, getParentExpression, getPublicId, getSpecialProperties, getSystemId, markTailFunctionCalls, process, resetStaticProperties, setLocationId, setParentExpression, typeError, typeError`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### VennExpression

    public VennExpression(Expression p1,
                          int op,
                          Expression p2)

  Constructor

Parameters:
  `p1` - the left-hand operand
  `op` - the operator (union, intersection, or difference)
  `p2` - the right-hand operand

Method Detail

### getItemType

    public final ItemType getItemType()

  Determine the data type of the items returned by this expression

  Returns:
    the data type

### computeCardinality

    public final int computeCardinality()

  Determine the static cardinality of the expression

  Overrides:
    `computeCardinality` in class `BinaryExpression`

### computeSpecialProperties

    public int computeSpecialProperties()

  Get the static properties of this expression (other than its type). The result is bit-signficant. These properties are used for optimizations. In general, if property bit is set, it is true, but if it is unset, the value is unknown.

  Overrides:
    `computeSpecialProperties` in class `BinaryExpression`
  Returns:
    `StaticProperty.NON_CREATIVE`. This is overridden for some subclasses.

### simplify

    public Expression simplify(StaticContext env)
                        throws XPathException

  Simplify the expression

  Specified by:
    `simplify` in interface `Expression`
  Overrides:
    `simplify` in class `BinaryExpression`
  Returns:
    the simplified expression
  Throws:
    `XPathException`

### analyze

    public Expression analyze(StaticContext env,
                              ItemType contextItemType)
                       throws XPathException

  Type-check the expression

  Specified by:
    `analyze` in interface `Expression`
  Overrides:
    `analyze` in class `BinaryExpression`
  Throws:
    `XPathException`

### hashCode

    public int hashCode()

  Is this expression the same as another expression?

  Overrides:
    `hashCode` in class `BinaryExpression`

### iterate

    public SequenceIterator iterate(XPathContext c)
                             throws XPathException

  Iterate over the value of the expression. The result will always be sorted in document order, with duplicates eliminated

  Specified by:
    `iterate` in interface `Expression`
  Overrides:
    `iterate` in class `ComputedExpression`
  Parameters:
    `c` - The context for evaluation
  Returns:
    a SequenceIterator representing the union of the two operands
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression

### effectiveBooleanValue

    public boolean effectiveBooleanValue(XPathContext context)
                                  throws XPathException

  Get the effective boolean value. In the case of a union expression, this is reduced to an OR expression, for efficiency

  Specified by:
    `effectiveBooleanValue` in interface `Expression`
  Overrides:
    `effectiveBooleanValue` in class `ComputedExpression`
  Parameters:
    `context` - The context in which the expression is to be evaluated
  Returns:
    the effective boolean value
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression